use ExtUtils::MakeMaker;
use Config;
use POSIX;

# Check if this is a 64 bit machine
my $CCFLAGS = '';
my $machine = (POSIX::uname())[4];
if ($machine =~ /64/) {
        $CCFLAGS = '-fPIC';
}

$CCFLAGS_DARWIN = '-arch x86_64 -g -pipe -fno-common -DPERL_DARWIN -fno-strict-aliasing -I/usr/local/include -m64 -fstrength-reduce -fthread-jumps -fcse-follow-jumps -fcse-skip-blocks -felide-constructors  -fschedule-insns -fschedule-insns2 -funroll-loops -fexpensive-optimizations';
#$CCFLAGS_DARWIN = '-arch x86_64 -g -pipe -fno-common -DPERL_DARWIN -fno-strict-aliasing -I/usr/local/include -m64'; 

my %params = (
	NAME         => 'libsetrecon',
	SKIP         => [qw(all static static_lib dynamic dynamic_lib)],
	C	     => ['prob_reconcile.cc constants.cc reconciled_set.cc prob_recon_support.cc'],
	H	     => ['constants.h polynomial.h prob_recon_support.h reconciled_set.h'],
	OBJECT       => 'prob_reconcile.o constants.o reconciled_set.o prob_recon_support.o',
	MYEXTLIB     => 'libsetrecon$(LIB_EXT)',
	clean        => {'FILES' => 'libsetrecon$(LIBEEXT) $(OBJECT)'},
);


print "OS type: $^O\n"; 
if ($^O =~ /darwin/)
{
	print "CCFLAGS = $CCFLAGS_DARWIN\n";
	$params{CCFLAGS} = $CCFLAGS_DARWIN;
}

WriteMakefile(%params);

sub MY::top_targets {
'
reconciled_set.o: reconciled_set.h constants.h prob_recon_support.h polynomial.h
constants.o: constants.h
prob_reconcile.o: prob_recon_support.h polynomial.h
prob_recon_support.o: prob_recon_support.h polynomial.h

all :: static

pure_all :: static

static :: $(OBJECT) libsetrecon$(LIB_EXT)

# main rules

libsetrecon$(LIB_EXT): $(O_FILES)
	$(AR) cr libsetrecon$(LIB_EXT) $(OBJECT)
	$(RANLIB) libsetrecon$(LIB_EXT)

';
}
