#!/usr/bin/perl -w

use SetRecon;

# first param: size of the elements (b bits)
# second param: maximal size of the symmetric difference (m)
$sketcher = new SetRecon(64, 5);

@set1 = ( 1, 6, 142, 273, 403, 53183748376, 661, 789, 918, 1046, 1170 );

print "Set 1: @set1\n";

# adding a set to the existing sketch
$sketcher->AddSet(\@set1);

# retrieving the sketch
my $sketch_data = $sketcher->GetSketchData();

while (($key, $val) = each %{$sketch_data})
{
	print "$key : ". ($key eq 'size' ? $val : "@{$val}") . "\n";
}

# removing the sketch
$sketcher->RemoveSketch();

@set2 = ( 6, 142, 272, 403, 53183748376, 661, 789, 918, 1046, 1174 );

print "Set 2: @set2\n";

# adding a new set
$sketcher->AddSet(\@set2);

my (@diffA, @diffB);

# it may return -1 in case reconciliation is unsuccessful (e.g., the symmetric difference is greater than m)
# , otherwise it returns the size of the symmetric difference
$res = $sketcher->GetDiff($sketch_data, \@diffA, \@diffB);

print "Result: $res\n";
print "Diff A: @diffA\n";
print "Diff B: @diffB\n";

#is($res, 5);
#is(join(' ', sort {$a <=> $b} @diff) eq "1 272 273 1170 1174", 1);

#print "Set A: @set1\n";
#print "Set B: @set2\n";

#print "Result: $res Diff: @diff\n";





